import request from '@/utils/request';
import type { ApiResult, PageResult } from '@/api';
import type { ThinkWechatBillLog, ThinkWechatBillLogParam } from './model';
import { THINK_API_URL } from '@/config/setting';

/**
 * 分页查询微信订单对账日志
 */
export async function pageThinkWechatBillLog(params: ThinkWechatBillLogParam) {
  const res = await request.get<ApiResult<PageResult<ThinkWechatBillLog>>>(
    THINK_API_URL + '/think/think-wechat-bill-log/page',
    {
      params
    }
  );
  if (res.data.code === 0) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 查询微信订单对账日志列表
 */
export async function listThinkWechatBillLog(params?: ThinkWechatBillLogParam) {
  const res = await request.get<ApiResult<ThinkWechatBillLog[]>>(
    THINK_API_URL + '/think/think-wechat-bill-log',
    {
      params
    }
  );
  if (res.data.code === 0 && res.data.data) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 添加微信订单对账日志
 */
export async function addThinkWechatBillLog(data: ThinkWechatBillLog) {
  const res = await request.post<ApiResult<unknown>>(
    THINK_API_URL + '/think/think-wechat-bill-log',
    data
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 修改微信订单对账日志
 */
export async function updateThinkWechatBillLog(data: ThinkWechatBillLog) {
  const res = await request.put<ApiResult<unknown>>(
    THINK_API_URL + '/think/think-wechat-bill-log',
    data
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 删除微信订单对账日志
 */
export async function removeThinkWechatBillLog(id?: number) {
  const res = await request.delete<ApiResult<unknown>>(
    THINK_API_URL + '/think/think-wechat-bill-log/' + id
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 批量删除微信订单对账日志
 */
export async function removeBatchThinkWechatBillLog(
  data: (number | undefined)[]
) {
  const res = await request.delete<ApiResult<unknown>>(
    THINK_API_URL + '/think/think-wechat-bill-log/batch',
    {
      data
    }
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 根据id查询微信订单对账日志
 */
export async function getThinkWechatBillLog(id: number) {
  const res = await request.get<ApiResult<ThinkWechatBillLog>>(
    THINK_API_URL + '/think/think-wechat-bill-log/' + id
  );
  if (res.data.code === 0 && res.data.data) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}
